# SPDX-FileCopyrightText: 2020 Mintlab B.V.
#
# SPDX-License-Identifier: EUPL-1.2

# AUTOGENERATED FILE - No need to edit
# GENERATED AT: 2022-09-26T13:04:54"
# Re-create by running 'generate-routes' command
# Run 'generate-routes --help' for more options

import os
from minty.exceptions import Conflict, NotFound
from pyramid.response import FileResponse


def apidocs_fileserver(request):
    """Serve files in the apidocs folder.

    :param request: request
    :type request: request
    :raises Conflict: wrong filetype (not JSON)
    :raises NotFound: file not found
    :return: file
    :rtype: JSON file
    """
    filename = request.matchdict["filename"]
    if not filename.endswith(".json"):
        raise Conflict(f"File: '{filename}' extension not allowed")

    # Take the name of this source file
    my_path = os.path.dirname(__file__)

    # Strip one level. This gives us the project root
    root_path = os.path.dirname(os.path.dirname(my_path))

    # Add "apidocs/filename" (use basename, so escaping the root using "../"
    # won't work)
    file_path = os.path.join(root_path, "apidocs", os.path.basename(filename))

    try:
        return FileResponse(file_path, request=request)
    except IOError as e:
        raise NotFound(f"File: '{filename}' not found") from e
